--
-- Table structure for table `check_astrad`
--

DROP TABLE IF EXISTS `check_astrad`;
CREATE TABLE `check_astrad` (
  `ast_host` varchar(80) NOT NULL default '',
  `reception` datetime NOT NULL default '0000-00-00 00:00:00',
  `verif` smallint(5) unsigned default NULL,
  `desc_` text,
  PRIMARY KEY  (`ast_host`,`reception`)
);


DELIMITER |
CREATE TRIGGER `Trg_Insert_check_astrad` AFTER INSERT ON `check_astrad` FOR EACH ROW BEGIN
DECLARE DATE_ datetime default NULL;
SET DATE_=(select from_unixtime(round(unix_timestamp(NEW.reception)/(60*30))*(60*30)));
IF (DATE_ > NEW.reception) THEN 
SET DATE_=DATE_ADD(DATE_, INTERVAL -30 MINUTE);
END IF;
INSERT INTO monit_graph VALUES (SUBSTRING_INDEX(NEW.ast_host, '.', 1),DATE_,NEW.verif,'check_astrad',CONCAT("ast_host='",NEW.ast_host,"' AND reception='",NEW.reception,"'")) ON DUPLICATE KEY UPDATE verif=NEW.verif, key_=CONCAT(key_," OR ast_host='",NEW.ast_host,"' AND reception='",NEW.reception,"'");
END |
DELIMITER ;

--
-- Table structure for table `check_dba`
--

DROP TABLE IF EXISTS `check_dba`;
CREATE TABLE `check_dba` (
  `dba_host` varchar(80) NOT NULL default '',
  `reception` datetime NOT NULL default '0000-00-00 00:00:00',
  `max_expires` datetime default NULL,
  `time_diff` int(5) default '0',
  `verif` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`dba_host`,`reception`)
);

DELIMITER |
CREATE TRIGGER `Trg_Insert_check_dba` AFTER INSERT ON `check_dba` FOR EACH ROW BEGIN
DECLARE DATE_ datetime default NULL;
SET DATE_=(select from_unixtime(round(unix_timestamp(NEW.reception)/(60*30))*(60*30)));
INSERT INTO monit_graph VALUES (SUBSTRING_INDEX(NEW.dba_host, '.', 1),DATE_,NEW.verif,'check_dba',CONCAT("dba_host='",NEW.dba_host,"' AND reception='",NEW.reception,"'")) ON DUPLICATE KEY UPDATE verif=NEW.verif, key_=CONCAT(key_,"OR dba_host='",NEW.dba_host,"' AND reception='",NEW.reception,"'");
END |
DELIMITER ;

--
-- Table structure for table `check_rep`
--

DROP TABLE IF EXISTS `check_rep`;
CREATE TABLE `check_rep` (
  `id` int(100) unsigned NOT NULL auto_increment,
  `date` datetime NOT NULL,
  `master` varchar(80) NOT NULL default '',
  `slave` varchar(80) NOT NULL default '',
  `Master_Log_File` varchar(80) default NULL,
  `Master_Log_Pos` int(10) unsigned default NULL,
  `Slave_Log_File` varchar(80) default NULL,
  `Slave_Log_Pos` int(10) unsigned default NULL,
  `Slave_IO_State` text,
  `Slave_Last_Errno` int(10) default NULL,
  `Slave_Last_Error` text,
  `count_tab` text,
  `sum_tab` text,
  `status` int(1) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `monitor_id` (`date`,`master`,`slave`)
);

DELIMITER |
CREATE TRIGGER `Trg_Insert_check_rep` AFTER INSERT ON `check_rep` FOR EACH ROW BEGIN
DECLARE DATE_ datetime default NULL;
SET DATE_=(select from_unixtime(round(unix_timestamp(NEW.date)/(60*30))*(60*30)));
IF (DATE_ > NEW.date) THEN 
SET DATE_=DATE_ADD(DATE_, INTERVAL -30 MINUTE);
END IF;
INSERT INTO monit_graph VALUES (CONCAT(SUBSTRING_INDEX(NEW.master, '.', 1),'->',SUBSTRING_INDEX(NEW.slave, '.', 1)),DATE_,NEW.status,'check_rep',CONCAT('id=',NEW.id)) ON DUPLICATE KEY UPDATE verif=NEW.status, key_=CONCAT(key_," OR id='",NEW.id);
END |
DELIMITER ;

--
-- Table structure for table `monit_graph`
--

DROP TABLE IF EXISTS `monit_graph`;
CREATE TABLE `monit_graph` (
  `label` varchar(80) NOT NULL default '',
  `date_` datetime NOT NULL default '0000-00-00 00:00:00',
  `verif` smallint(5) unsigned default NULL,
  `table_` varchar(80) NOT NULL default '',
  `key_` text,
  PRIMARY KEY  (`label`,`date_`)
);

-- Dump completed on 2011-07-27  9:48:34
