#!/usr/bin/perl 
##########################################################################
#                                                                        #
# Perl Script for check mysql replication                                #
# Switzernet(c)2011                                                      #
#                                                                        #
##########################################################################
# my modules
use strict;
use warnings;
#use diagnostics;
use POSIX;
use Config::IniFiles;
use Switch;
use DBI;
use Date::Manip;
use MIME::Lite;
##########################################################################
# Setting
my $config_file = '/root/folders/110725-check-dba/check-dba.conf';
##########################################################################
# Globals
my ($DB_LOC_NAME,$DB_LOC_USER,$DB_LOC_PASS,$DB_LOC_TAB,$DB_DBA_USER,$DB_DBA_PASS);
my @DBAs;
##########################################################################
#                             Initialization                             #
##########################################################################
# Remove leading and trailing white space from a string
sub chomp_plus {
my $string=shift;
$string =~ s/^\s+//;$string =~ s/\s+$//;
chomp $string;
return $string;
}
##########################################################################
# Load config from mysql.conf
sub load_config {
my $conf=Config::IniFiles->new(-file => $config_file);
return 0 if !defined $conf ;
my @tDBAs   = split(',', $conf->val('GLOBAL','DBAs'));
foreach my $i (@tDBAs) {
   my $j=chomp_plus($i);
   push (@DBAs,$j);
   }
$DB_LOC_NAME = $conf->val('GLOBAL','DBname');
$DB_LOC_USER = $conf->val('GLOBAL','Luser');
$DB_LOC_PASS = $conf->val('GLOBAL','Lpass');
$DB_LOC_TAB  = $conf->val('GLOBAL','Table');
$DB_DBA_USER = $conf->val('GLOBAL','Suser');
$DB_DBA_PASS = $conf->val('GLOBAL','Spass');

return 1;
}
##########################################################################
# DB connect 
sub DB_connect {
my($DB_NAME,$DB_HOST,$DB_USER,$DB_PASS) = @_;
my $cop=0;
my $tdbh;
while( 1 ) {
        $cop++;
        $tdbh = DBI->connect_cached("DBI:mysql:$DB_NAME;host=$DB_HOST", $DB_USER, $DB_PASS);
        if( $tdbh ) {
	   return $tdbh;
           } 
        else {
           return 0 if ($cop>=3);
	   }
        sleep $cop;
	}
}
#########################################################################
# checksum table
sub get_min_max {
my $dbh=shift;
my $vr;
my $query = 'SELECT MIN(max_register) as register,NOW(),TIMESTAMPDIFF(SECOND,MIN(max_register),NOW()) as diff, CASE WHEN TIMESTAMPDIFF(SECOND,MIN(max_register),NOW())<60 THEN "1" ELSE CASE WHEN TIMESTAMPDIFF(SECOND,MIN(max_register),NOW())<150 THEN "2" ELSE "3" END END as vr from (select username,domain,MAX(register) as max_register , 1 as grp from location2 group by domain) as loc group by grp;';
my $sqlQuery  = $dbh->prepare($query) or return;
$sqlQuery->execute or return;
my @row= $sqlQuery->fetchrow_array();
$sqlQuery->finish;
return @row;
}
##########################################################################
#                                 main()                                 #
##########################################################################
load_config();
my $ldbh=DB_connect($DB_LOC_NAME,'localhost',$DB_LOC_USER,$DB_LOC_PASS);
foreach my $i (@DBAs) {
   my $dbh=DB_connect('astrad',$i,$DB_DBA_USER,$DB_DBA_PASS);
   my @res=get_min_max($dbh);
#   print "DBA=$i expires=".$res[0]." | NOW()=".$res[1]." | diff=".$res[2]." | vr=".$res[3]."\n";
   $ldbh->do("INSERT INTO $DB_LOC_TAB values ('$i','$res[1]','$res[0]','$res[2]',$res[3]);");
#   print "INSERT INTO $DB_LOC_TAB values ('$i','$res[1]','$res[0]','$res[2]',$res[3]);\n";
   $dbh->disconnect ;
   }
$ldbh->disconnect ;
##########################################################################
#                                  END                                   #
##########################################################################
